#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <ctype.h>
#include <fcntl.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <sys/wait.h>
#include <qdos.h>
#include <qptr.h>
#include <dirent.h>
#include <unistd.h>
#include <things.h>
#include <menu.h>

#define VERSION "0.02"

extern int jcall (void (*)(), char *, int, int, int,...);     

#define BACKUP  'c'
#define RESTORE 'x'
#define LIST    't'
#define SEP '_'

char _prog_name[] = "bruz " VERSION;
void (*_consetup)() = consetup_title;
long _stack = 12000;  
static int block = 0;

/*----------------------------------------------------------------------------.
|   The only reason for this is because calling wman a 'window manager' is an |
|   oxymoron.								      |
`----------------------------------------------------------------------------*/

void screen(int chan, FILE *log)
{
    char buf[256];
    int n;
    
    while(1)
    {
	while(block) mt_susjb(-1, 1, NULL);
	if((n = io_fline(getchid(chan), -1, buf, sizeof(buf)-1)) > 0)
	{
	    while(block) mt_susjb(-1, 1, NULL);
	    io_sstrg(getchid(2), -1, buf, n);
	    if(log)
	    {
		*(buf+n) = 0;
		fputs (buf, log);
	    }
	} 
    }
}

int Confirm(char *ctl,...)
{
    va_list va;
    char t[256];
    int res;

    va_start (va, ctl);
    vsprintf (t, ctl, va);
    block = 1;
    res = ItemSelect(_prog_name, t, "OK", NULL, NULL, -1, -1, -1);
    block = 0;
    return res;
}

void cleandir(char *nam)
{
    DIR *d;
    struct stat s;
    int n; 

    d = opendir(nam);
    if(d)
    {
        struct dirent *p;
        while(p = readdir(d))
        {
            char *pd, d_name[PATH_MAX];
	    
	    if(*p->d_name == '.' && 
	       (*(p->d_name+1) == 0 || *(p->d_name+1) == '.'))
		continue;
	    
            pd = stpcpy(d_name, nam);
	    if(*(pd-1) != SEP)
	    {
		*pd++ = SEP;
	    }
	    strcpy(pd, p->d_name);
            n = stat(d_name, &s);
            if(S_ISDIR(s.st_mode))
            {
                cleandir(d_name);
            }
	    unlink (d_name);		
        }
	closedir(d);
    }     
}

void setblock(int fd)
{
    long flags;
    flags = fcntl( fd, F_GETFL, 0);
    fcntl( fd, F_SETFL, flags &~ O_NDELAY);     
}

#ifdef GU
void ShowIOError(int err, int err1, int id)
{
    char t[80];
    sprintf (t, "step %d, err %d, oserr %d",  id, err, err1);
    ItemSelect("*** ERROR ***", t, "OK", NULL, NULL, -1, -1, -1);
    return ReportError(err1, 0, 0, -1);
}
#else
# define ShowIOError(__p1,__p2,__p3) ReportError(__p2,0,0,-1)
#endif

int spawntar (char *prog, int dirn, int *chan, int via)
{
    int pipes[2];
    int err,cpid;
    int chans[4];
    char **pa, *args[16];
    char *p1, *p2, *ptr;

    ptr = strdup(prog);

    err = pipe(pipes);
    setblock(pipes[0]);
    setblock(pipes[1]);
    if (err < 0) 
    {
	ShowIOError (err, _oserr, 1);
	exit(0);
    }
    
    pa = args;
    for(p1 = ptr; (p2 = strtok(p1, "\t ")); p1 = NULL)
    {
	*pa++ = p2;
    }
    *pa = NULL;

    if(dirn == BACKUP) /* backup */
    {
	/* reading archive */
	*chan  = pipes[0];
	*(chans+0) = 3;
	*(chans+1) = -1;
	*(chans+3) = pipes[1];
	*(chans+2) = via;
	cpid = forkvp (args[0], chans, args);
    }
    else
    {
	*chan = pipes[1];
	*(chans+0) = 3;
	*(chans+1) = pipes[0];
	*(chans+2) = via;
	*(chans+3) = via;
	cpid = forkvp (args[0], chans, args);
    }
    if(cpid < 0)
    {
	ShowIOError (cpid, _oserr, 2);
	exit(0);
    }
    free(ptr);
    return cpid;
}

int opentarfile(char *fnam, char *to, int id, char *suffix, 
		int iomode, int limit, short verbose)
{
    char t;
    int fd;
    char buf[80];

    t = '^';
    if((iomode & O_WRONLY) && limit <= 0)
    {
	fd = io_open(to, 4);
	io_close(fd);

	if(fd < 0 || limit < 0)
	{
	    short good, totl;
	    char uc, *us = strchr(to, '_');
	    if(us) 
	    {
		uc = *(us+1);
		*(us+1) = 0;
	    }
	    while((fd = io_format(to, &good, &totl)) != 0)
	    {
		if( ShowIOError(_oserr, fd, 3)) exit(fd);
	    }

	    *(us+1) = uc;
	    if(verbose)
	    {
		sprintf(buf,"%s good %d, total %d", to, good, totl);
		ItemSelect("Format", buf,  
			   "OK", NULL, NULL, -1, -1, -1);
	    }
	}
	else 
	{		
	    cleandir(to);
	}
    }
    sprintf(fnam, "%s%cbackup_%03x_tar%s", to, t, id, suffix);
    fd = open(fnam, iomode, 0666);
    if(iomode == O_RDONLY && fd == -1)
    {
	sprintf(fnam, "%s~backup_%03x_tar%s", to, id, suffix);
	fd = open(fnam, iomode, 0666);
    }
    return fd;
}
static void usage(void)
{
    Confirm("usage: bruz [-b|r|l] [-z|X] [-m LIM] [-v] [-t taropt] [infile] [outfile] [pattn]");
    exit(0);
}

static int parselim(char *q, char **p)
{
    int limit;
    char *s = NULL;

    limit = strtol(q, &s, 10);
    if(s && ((*s | ' ') == 'k'))
    {
	limit <<= 10;
	if(p) *p = s + 1;
    }
    return limit;
}
static FILE* logfl (char *p)
{
    char lf[64];
    sprintf(lf, p, time(NULL));
    return fopen(lf, "w");
}

int main(int ac, char **av)
{
    char *from = NULL;
    char *to = NULL;
    char outf[36];
    int limit = 0;
    int n, sz, mode = 0, chan;
    char cmd[80];
    char buf[512], fnam[36];
    int c, fd, id = 0;
    char compr = -1;
    char *suffix, opts[3];
    int cpid;
    short nop = 0;
    int totl = 0;
    char *taropt = "";
    short verbose = 0;
    char *opt, *pattn = NULL;
    int via[2];
    FILE *log = NULL;
    char *logfmt = NULL;

    if(opt = getenv("BRUZ_OPTS"))
    {
	char *q;
	for(q = opt; *q; q++)
	{
	    if(*q == '-')
	    {
		q++;
		switch(*q)
		{
		    case 'z':
			compr = 'z';
			break;
		    case 'v':
			verbose ^= 1;
			break;
		    case 'n':
			nop ^= 1;
			break;
		    case 'X':
			compr = 0;
			break;
		    case 'm':
			q++;
			limit = parselim(q, &q);
			break;
		    case 'L':
			q++;
			while(*q && *q <= ' ') 
			    q++;
			logfmt = q;
			while(*q && *q > ' ') 
			    q++;
			*q = 0;
			break;
		}
	    }
	}
    }

    while((c = getopt(ac, av,"brlzm:vnt:p:h?XL:")) != EOF)
    {
	switch(c)
	{
	    case 'b':
		mode = BACKUP;
		break;
	    case 'r':
		mode = RESTORE;
		break;
	    case 'l':
		mode = LIST;
		break;
	    case 'z':
		compr = c;
		break;
	    case 'X':
		compr = 0;
		break;
	    case 'm':
		limit = parselim(optarg, NULL);
		break;
	    case 'n':
		nop ^= 1;
		break;
	    case 'p':
		pattn = optarg;
		break;
	    case 'v':
		verbose ^= 1;
		break;
	    case 't':
		taropt = optarg;
		break;
	    case 'L':
		logfmt = optarg;
		break;
	    case 'h':
	    case '?':
	    default:
		usage();
		break;
	}
    }

    {
	extern char *_endmsg;
	_endmsg = NULL;  
    }

    if(mode == 0)
    {
	int n;
	static char val[3] = "cxt";
	n = ItemSelect(_prog_name, "Mode ?", 
		       "Backup", "Restore", "List", -1, -1, -1);
	if( n> 0)
	    mode = *(val+n-1);
    }

    if(mode)
    {
	if(optind < ac) from = *(av+optind);
	if(mode != 't')
	{
	    optind++;
	    if(optind < ac) to = *(av+optind);
	}
	else to = "";

	if (from == NULL)
	{
	    char buf[40] = "";
	    n = DirSelect ("From Directory", buf, 0, -1, -1, -1, -1);
	    if(n == 0)
	    {
		from = strdup(buf);
	    }
	}
	if(from)
	{
	    if(to == NULL && mode)
	    {
		char buf[40] = "";
		n = DirSelect ("To Directory", buf, 0, -1, -1, -1, -1);
		if(n == 0)
		{
		   to = strdup(buf);
		}
	    }
	}
    }

    if(from && to && mode)
    {
	if(compr == -1)
	{
	    int n;
	    compr = 0;
	    n = ItemSelect(_prog_name, "Use compression ?", 
		       "Yes", "No", NULL, -1, -1, -1);
	    if(n == 1) compr = 'z';
	}

	*(opts+0) = mode;
	*(opts+1) = tolower(compr);
	*(opts+2) = '\0';

	if(compr)
	{
	    char *s;
	    short nf = 0;

	    if((s = getenv("TAR_COMPRESS")) && 
	       (NULL == strstr(strlwr(s), "compress")))
	    {
		suffix = "_gz";
	    }
	    else
	    {
		suffix = "_Z";
	    }

	    if(!s) 
	    {
		nf = 1;
	    }
	    else
	    {
		if((nf = access(s, X_OK)))
		{
		    char fnm[40];
		    getcpd(fnm, sizeof(fnm));
		    strcat(fnm, s);
		    nf = access(fnm, X_OK);
		}
	    }
	    if(nf)
	    {
		ShowIOError(0, ERR_NF, 0);
		exit(ERR_NF);
	    }
	}
	else suffix = "";

	if(mode != LIST)
	{
	    strcpy(outf, "-C");
	    strcpy(outf+2, (mode == BACKUP) ? from : to);
	}
	else *outf = 0;

	sprintf(cmd, "tar %s %s -%svf - ", outf, taropt, opts);

	if(pattn)
	{
	    strcat(cmd, pattn);
	}
	else if (mode == BACKUP) strcat(cmd, ".");

	{
	    int x = _pipesize;
	    _pipesize = 256;
	    pipe(via);
	    setblock(via[0]);
	    setblock(via[1]);
	    _pipesize = x;
	}

	if(logfmt)
	{
	    if((log = logfl(logfmt)))
	    {
		time_t t;
		t = time(NULL);
		fprintf(log, "bruz log, mode = %c, time  = %s", 
			mode, ctime(&t));
	    }
	}

	jcall(screen, "oxymoron", 1, 1024, 2, via[0], log);
	cpid = spawntar(cmd, mode, &chan, via[1]);
	fd = -1;


	if(mode == BACKUP)
	{
	    if(nop == 0)
	    {
		if(Confirm("Please insert first disk in %s", to) < 0)
		    exit(0);
	    }

	    while((n = read(chan, buf, 512)) > 0)
	    {
		int w;

		totl += n;

		if(fd == -1)
		{
		    sz = 0;
		    fd = opentarfile(fnam, to, id, suffix, 
				     O_CREAT|O_WRONLY|O_TRUNC, limit, verbose);
		}
		w = write(fd, buf, n);
		while (w != n)
		{
		    sz = 0;
		    close(fd);
		    id++;
		    if(nop == 0)
			Confirm("Please insert next disk in %s", to);

		    fd = opentarfile(fnam, to, id, suffix,
				     O_CREAT|O_WRONLY|O_TRUNC, limit, verbose);
		    w = write(fd, buf, n);
		}
		sz += n;
		if(limit > 0 && (sz >= limit))
		{
		    if(nop == 0)
			Confirm("Please insert next disk in %s", to);
		    close(fd);
		    id++;
		    fd = -1;
		}
	    }
	    if(fd > 0)
	    {
		close(fd);
	    }
	    {
		char *q, onam[36];
		int n;
		if((q = strchr(fnam, '^')))
		{
		    strcpy(onam, fnam);
		    *q = '~';
		    n = rename (onam, fnam);
		}
	    }
	}
	else
	{
	    short done = 0;
	    while(!done)
	    {
		int nc;
		for(nc = 0; (fd == -1); nc++)
		{
		    int res = 1;

		    if(nop || nc)
		    {
			if (Confirm ("Please load archive %d in %s", 
				       id, from) < 0) exit(0);
		    }
		    fd = opentarfile(fnam, from, id, 
					    suffix, O_RDONLY, limit, verbose);
		}
		id++;

		while((n = read(fd, buf, 512)))
		{
		    totl += n;
		    write(chan, buf, n);
		}
		close(fd);
		fd = -1;
		done = (strchr(fnam, '~') != NULL);
	    }
	}
	close(chan);
	{
	    int status, child;
	    while (((child = wait(&status)) != cpid))
		/* */;
	    cpid = 0;
	} 
    }
    else usage();

    if(verbose)
    {
	Confirm("Processed %d bytes", totl);
    }
    if(log) fclose(log);
    return 0;
}
